<!DOCTYPE html>
<html>
<head>
  <meta charset="utf-8">
  <meta name="generator" content="pandoc">
  <meta name="author" content="Winnie">
  <meta name="dcterms.date" content="2020-01-12">
  <title>Mastodon bots mit GitLab</title>
  <meta name="apple-mobile-web-app-capable" content="yes">
  <meta name="apple-mobile-web-app-status-bar-style" content="black-translucent">
  <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no, minimal-ui">
  <link rel="stylesheet" href="reveal.js/css/reveal.css">
  <style type="text/css">code{white-space: pre;}</style>
  <link rel="stylesheet" href="reveal.js/css/theme/white.css" id="theme">
  <link rel="stylesheet" href="style.css"/>
  <!-- Printing and PDF exports -->
  <script>
    var link = document.createElement( 'link' );
    link.rel = 'stylesheet';
    link.type = 'text/css';
    link.href = window.location.search.match( /print-pdf/gi ) ? 'reveal.js/css/print/pdf.css' : 'reveal.js/css/print/paper.css';
    document.getElementsByTagName( 'head' )[0].appendChild( link );
  </script>
  <!--[if lt IE 9]>
  <script src="reveal.js/lib/js/html5shiv.js"></script>
  <![endif]-->
</head>
<body>
  <div class="reveal">
    <div class="slides">

<section>
  <h1 class="title"><a href="https://joinmastodon.org/">Mastodon</a> bots mit <a href="https://about.gitlab.com/">GitLab</a></h1>
  <p class="author"><a href="https://winniehell.de">Winnie</a></p>
  <p class="date">2020-01-12</p>
</section>

<section id="worum-gehts" class="slide level2">
<h2>Worum geht's?</h2>
<ul>
<li>Beispielbot</li>
<li>Motivation</li>
<li>Pipeline schedules in GitLab</li>
<li>easy-toot / easy-tweet</li>
<li>Mastodon-Bot</li>
<li>Live Demo?</li>
<li>Alternative</li>
</ul>
</section>
<section><section id="beispielbot" class="titleslide slide level1"><h1>Beispielbot</h1></section><section class="slide level2">

<figure>
<img src="img/screenshot-comic-bot.png" alt="Screenshot of toot by bot" /><figcaption>Screenshot of toot by bot</figcaption>
</figure>
</section><section class="slide level2">

<ul>
<li>dreimal pro Woche neuer Comic</li>
<li>auf Twitter: <a href="https://twitter.com/bastianmelnyk/">@bastianmelnyk</a></li>
<li>auf Mastodon: <a href="https://mastodon.social/@bastianmelnyk">@bastianmelnyk@mastodon.social</a></li>
<li>vollständig automatisiert: <a href="https://gitlab.com/fonflatter/bots/comic" class="uri">https://gitlab.com/fonflatter/bots/comic</a></li>
<li>läuft seit August 2019</li>
</ul>
</section></section>
<section><section id="motivation" class="titleslide slide level1"><h1>Motivation</h1></section><section id="anforderungen" class="slide level2">
<h2>Anforderungen</h2>
<ul>
<li>feste Verbreitungszeitpunkte brauchen Server</li>
<li>Monitoring / Logging wäre nett</li>
<li>Weboberfläche erleichtert Unterwegsität</li>
</ul>
</section><section id="gitlab.com" class="slide level2">
<h2>gitlab.com</h2>
<ul>
<li>bietet kostenlose Server</li>
<li>Pipelines haben Logs</li>
<li>…und E-Mail-Benachrichtigungen</li>
<li>Config kann im Browser geändert werden</li>
<li>Pipelines können gestartet/gestoppt werden</li>
</ul>
</section></section>
<section><section id="pipeline-schedules" class="titleslide slide level1"><h1>Pipeline schedules</h1></section><section id="pipelines" class="slide level2">
<h2><a href="https://docs.gitlab.com/ee/ci/pipelines.html">Pipelines</a></h2>
<ul>
<li>Sammlung von Jobs</li>
<li>jeder Job</li>
<li>läuft in definierter Umgebug</li>
<li>auf einem Server von GitLab</li>
<li>führt beliebige Programme aus</li>
<li>analog zu mehrere Tabs in Konsole</li>
</ul>
</section><section id="pipeline-schedules-1" class="slide level2">
<h2><a href="https://docs.gitlab.com/ee/user/project/pipelines/schedules.html">Pipeline schedules</a></h2>
<ul>
<li>Pipelines die zu festem Zeitpunkt laufen</li>
<li>Beispiel: <a href="https://gitlab.com/winnie-demos/pipeline-schedules" class="uri">https://gitlab.com/winnie-demos/pipeline-schedules</a></li>
</ul>
</section></section>
<section><section id="easy-toot-easy-tweet" class="titleslide slide level1"><h1>easy-toot / <br> easy-tweet</h1></section><section class="slide level2">

<ul>
<li>starke Vereinfachung der Twitter / Mastodon API</li>
<li>erwartet Token und Eingabedatei</li>
<li>Mastodon: <a href="https://gitlab.com/winniehell/easy-toot/" class="uri">https://gitlab.com/winniehell/easy-toot/</a></li>
<li>Twitter: <a href="https://gitlab.com/winniehell/easy-tweet/" class="uri">https://gitlab.com/winniehell/easy-tweet/</a></li>
</ul>
</section></section>
<section><section id="mastodon-bot" class="titleslide slide level1"><h1>Mastodon-Bot</h1></section></section>
<section><section id="live-demo" class="titleslide slide level1"><h1>Live Demo? 🙀</h1></section></section>
<section><section id="alternative" class="titleslide slide level1"><h1>Alternative</h1></section><section id="monit" class="slide level2">
<h2><a href="https://mmonit.com/monit/">monit</a></h2>
<ul>
<li>start/stop von bot</li>
<li>logs lesen</li>
<li>E-Mail-Benachrichtigungen</li>
<li>braucht eigenen Server</li>
<li>keine Möglichkeit Konfiguration zu bearbeiten</li>
</ul>
</section></section>
<section><section id="fertsch." class="titleslide slide level1"><h1>fertsch.</h1></section></section>
    </div>
  </div>

  <script src="reveal.js/lib/js/head.min.js"></script>
  <script src="reveal.js/js/reveal.js"></script>

  <script>

      // Full list of configuration options available at:
      // https://github.com/hakimel/reveal.js#configuration
      Reveal.initialize({
        // Transition style for full page slide backgrounds
        backgroundTransition: 'none', // none/fade/slide/convex/concave/zoom

        // Optional reveal.js plugins
        dependencies: [
          { src: 'reveal.js/lib/js/classList.js', condition: function() { return !document.body.classList; } },
          { src: 'reveal.js/plugin/zoom-js/zoom.js', async: true },
              { src: 'reveal.js/plugin/notes/notes.js', async: true }
        ]
      });
    </script>
    </body>
</html>
